using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;
using System.IO;
using System.Net;


namespace ExtendedWebBrowser2
{
    internal partial class FavoritesSelector : UserControl 
    {

        #region 

        public FavoritesSelector() {
            _direNodes = new Dictionary<string, TreeNode>();
            InitializeComponent();
            this.InitializeImages();
            this.mTSMenuAdd.Click += new EventHandler(mTSMenuAdd_Click);
            this.Browser = null;
            this.treeView1.MouseDown += new MouseEventHandler(treeView1_MouseDown);
            this.treeView1.MouseUp += new MouseEventHandler(treeView1_MouseUp);
            this.treeView1.MouseMove += new MouseEventHandler(treeView1_MouseMove);
            this.treeView1.MouseWheel += new MouseEventHandler(treeView1_MouseWheel);
            this.treeView1.Leave += new EventHandler(treeView1_Leave);
            this.treeView1.ShowRootLines = false;
        }


        private void InitializeImages() {

            this.imageList1.ImageSize = new Size(16, 16);
            //this.imageList1.Images.Clear();
            //this.AddImage(global::DomainGenie.Properties.Resources.standardOrange_Folder_Closed);
            //this.AddImage(global::DomainGenie.Properties.Resources.standardOrange_Folder_Opened);
            //this.AddImage(global::DomainGenie.Properties.Resources.ie);

            this.treeView1.ImageList = this.imageList1;
        }

        private void AddImage(Icon ic) {
            Bitmap bmp = new Bitmap(16, 16);
            using (Graphics g = Graphics.FromImage(bmp)) {
                g.Clear(this.treeView1.BackColor);
                g.DrawIcon(ic, new Rectangle(0, 0, 16, 16));
            }
            this.imageList1.Images.Add(bmp);
            this.treeView1.ImageList = this.imageList1;
        }

        public void SetBackColor(Color col) {
            this.treeView1.BackColor = col;
            this.InitializeImages();
        }


        #endregion

        #region
        public TreeView TreeView {
            get { return this.treeView1; }
        }
        #endregion

        public MenuStrip MenuStrip {
            get { return this.menuStrip1; }
        }

        private Dictionary<string, TreeNode> _direNodes;

        private string rootDirectory = "";
        public void InitNodes() {
            this.treeView1.BeginUpdate();
            Cursor.Current = Cursors.WaitCursor;
            this.treeView1.Nodes.Clear();
            _direNodes = new Dictionary<string, TreeNode>();
            string fdire = Environment.GetFolderPath(Environment.SpecialFolder.Favorites);
            rootDirectory = fdire;
            DirectoryInfo di = new DirectoryInfo(fdire);
            DirectoryInfo[] dlist = di.GetDirectories();
            if (dlist != null) {
                foreach (DirectoryInfo dic in dlist) {
                    TreeNode tn = new TreeNode(dic.Name, 0, 1);
                    this.treeView1.Nodes.Add(tn);
                    _direNodes.Add(dic.FullName, tn);
                    this.AddNodes(tn, dic);
                }
            }
            
            FileInfo[] flist = di.GetFiles();
            if (flist != null) {
                foreach (FileInfo fi in flist) {
                    if (fi.Extension.Equals(".url")) {
                        string text = fi.Name.Substring(0, fi.Name.Length - 4);
                        TreeNode tn = new TreeNode(text, 2, 2);
                        tn.ToolTipText = text;// +Environment.NewLine + fi.CreationTime.ToString();
                        tn.Tag = fi;
                        this.treeView1.Nodes.Add(tn);
                    }
                }
            }
            Cursor.Current = Cursors.Default;
            this.treeView1.EndUpdate();
        }
        private void AddNodes(TreeNode root, DirectoryInfo di) {
            DirectoryInfo[] dlist = di.GetDirectories();
            if (dlist != null) {
                foreach (DirectoryInfo dic in dlist) {
                    TreeNode tn = new TreeNode(dic.Name, 0, 1);
                    root.Nodes.Add(tn);
                    _direNodes.Add(dic.FullName, tn);
                    this.AddNodes(tn, dic);

                }
            }
            FileInfo[] flist = di.GetFiles();
            if (flist != null) {
                foreach (FileInfo fi in flist) {
                    if (fi.Extension.Equals(".url")) {
                        string text = fi.Name.Substring(0, fi.Name.Length - 4);
                        TreeNode tn = new TreeNode(text, 2, 2);
                        tn.ToolTipText = text;// +Environment.NewLine + fi.CreationTime.ToString();
                        tn.Tag = fi;
                        root.Nodes.Add(tn);
                    }
                }
            }
        }

        void treeView1_MouseWheel(object sender, MouseEventArgs e) {
            if (!treeView1.Focused) {
                Point p = treeView1.AutoScrollOffset;
                if (e.Delta > 0) {
                    treeView1.AutoScrollOffset = new Point(p.X, p.Y - 10);
                } else {
                    treeView1.AutoScrollOffset = new Point(p.X, p.Y + 10);
                }
            }
            //treeView1.AutoScrollOffset
        }
        #region 
        /*
        public void ScrollNode(int dy) {
            if (dy < 0) {
                TreeNode tn = treeView1.TopNode;
                if (tn != null) {
                    TreeNode tn2 = tn.PrevNode;
                    if (tn2 != null) {
                        int i = Math.Abs(dy) - 1;
                        while (dy-- > 0) {
                            if (tn2.PrevNode == null) {
                                if (tn2.Parent != null && tn2.Parent.PrevNode != null) {
                                    tn2 = tn2.Parent.PrevNode;
                                    continue;
                                } else {
                                    break;
                                }
                            }
                        }
                        tn2.EnsureVisible();
                    }
                }
            } else {
                TreeNode tn = treeView1.GetNodeAt(new Point(0, treeView1.Height - treeView1.ItemHeight-1));
                
                if (tn != null) {
                    TreeNode tn2 = tn.NextNode;
                    if (tn2 != null) {
                        int i = Math.Abs(dy) - 1;
                        while (dy-- > 0) {
                            if (tn2.NextNode == null) {
                                if (tn2.Parent != null && tn2.Parent.NextNode != null) {
                                    tn2 = tn2.Parent.NextNode;
                                    continue;
                                } else {
                                    break;
                                }
                            }
                        }
                        tn2.EnsureVisible();
                    }
                }
            }
        }
        */
        #endregion

        public string GetUrl(TreeNode node) {
            if (node.Tag is FileInfo) {
                FileInfo fi = node.Tag as FileInfo;
                using(FileStream fs = new FileStream(fi.FullName, FileMode.Open, FileAccess.Read))
                using (StreamReader sr = new StreamReader(fs)) {
                    while (!sr.EndOfStream) {
                        string line = sr.ReadLine();
                        if (line.StartsWith("URL=")) {
                            string ret = line.Substring(4);
                            if (ret.StartsWith("http")) {
                                return ret;
                            }
                        }
                    }
                }                
            }
            return "";
        }

        private bool _mouseDown;

        void treeView1_Leave(object sender, EventArgs e) {
            _mouseDown = false;   
        }

        void treeView1_MouseMove(object sender, MouseEventArgs e) {
            if (_mouseDown){
                if (this.treeView1.SelectedNode != null && this.treeView1.SelectedNode.Tag != null) {
                    FileInfo fi = this.treeView1.SelectedNode.Tag as FileInfo;
                    DataObject dobj = new DataObject(DataFormats.FileDrop, new string[] { fi.FullName });
                    _mouseDown = false;
                    this.DoDragDrop(dobj, DragDropEffects.Link);
                }
            }
        }

        void treeView1_MouseUp(object sender, MouseEventArgs e) {
            _mouseDown = false;
        }

        void treeView1_MouseDown(object sender, MouseEventArgs e) {
            TreeNode tn= this.treeView1.GetNodeAt(e.Location);

            if (tn != null && tn.Tag!=null) {
                if (tn.Bounds.Contains(e.Location)) {
                    _mouseDown = true;
                    this.treeView1.SelectedNode = tn;
                }
            }
        }









        //Include the following interface declaration just before your application's namespace
        //declaration to add a reference to the Microsoft HTML (MSHTML) IOleCommandTarget interface
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct OLECMDTEXT
        {
            public uint cmdtextf;
            public uint cwActual;
            public uint cwBuf;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 100)]
            public char rgwz;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct OLECMD
        {
            public uint cmdID;
            public uint cmdf;
        }

        // Interop definition for IOleCommandTarget.
        [ComImport,
        Guid("b722bccb-4e68-101b-a2bc-00aa00404770"),
        InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
        public interface IOleCommandTarget
        {
            //IMPORTANT: The order of the methods is critical here. You
            //perform early binding in most cases, so the order of the methods
            //here MUST match the order of their vtable layout (which is determined
            //by their layout in IDL). The interop calls key off the vtable ordering,
            //not the symbolic names. Therefore, if you switched these method declarations
            //and tried to call the Exec method on an IOleCommandTarget interface from your
            //application, it would translate into a call to the QueryStatus method instead.
            void QueryStatus(ref Guid pguidCmdGroup, UInt32 cCmds,
                [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 1)] OLECMD[] prgCmds, ref OLECMDTEXT CmdText);
            void Exec(ref Guid pguidCmdGroup, uint nCmdId, uint nCmdExecOpt, ref object pvaIn, ref object pvaOut);
        }




        void mTSMenuAdd_Click(object sender, EventArgs e) {
            this.ShowAddToFavorites();
        }
        private void mTSMenuOrganize_Click(object sender, EventArgs e) {
            this.OrganizeFavorites();
        }

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern IntPtr SendMessage(HandleRef hhWnd, uint Msg,
                IntPtr wParam, IntPtr lParam);
        [DllImport("user32.dll", ExactSpelling = true, CharSet = CharSet.Auto)]
        public static extern IntPtr GetWindow(IntPtr hWnd, int uCmd); 

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern IntPtr FindWindow(string pClassName, string pWindowName);
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern IntPtr FindWindowEx(IntPtr parent /*HWND*/,
              IntPtr next /*HWND*/, string sClassName, string sWindowTitle);
        

        [DllImport("user32.Dll")]
        public static extern void GetClassName(int h, StringBuilder s, int nMaxCount);

        public const int S_OK = 0;
        public static Guid CLSID_ShellUIHelper = new Guid("64AB4BB7-111E-11D1-8F79-00C04FC2FBE1");
        private const int ID_IE_CONTEXTMENU_ADDFAV = 2261;

        public const int WM_COMMAND = 0x0111;
        public const int GW_HWNDNEXT = 2;
        public const int GW_CHILD = 5;
        
        private ExtendedWebBrowser mBrowser;
        public ExtendedWebBrowser Browser
        {
            get { return mBrowser; }
            set {
                mBrowser = value;
                if (value == null) {
                    //this.mTSMenuAdd.Enabled = false;
                } else if (!this.mTSMenuAdd.Enabled) {
                    this.mTSMenuAdd.Enabled = true;
                }
            }
        }

        bool bPopped = false;
        public void ShowAddToFavorites()
        {
            if (mBrowser == null)
                return;

            if (bPopped)
            {
                bPopped = false;
                return;
            }
            bPopped = true;

            if (mBrowser == null) return;

            IOleWindow iole = mBrowser.ActiveXInstance as IOleWindow;

            if (iole == null) return;
            IntPtr hShellEmbedding = IntPtr.Zero;
            iole.GetWindow(ref hShellEmbedding);

            if (hShellEmbedding.ToInt32() == 0) return;
            IntPtr hShellDockObje = IntPtr.Zero;
            hShellDockObje = GetWindow(hShellEmbedding, GW_CHILD);

            if (hShellDockObje.ToInt32() == 0) return;
            IntPtr hwnd = GetWindow(hShellDockObje, GW_CHILD);

            if (hwnd.ToInt32() != 0) {
                HandleRef hhwnd = new HandleRef(this.TopLevelControl, hwnd);
                IntPtr nullHwnd = IntPtr.Zero;
                IntPtr v = SendMessage(hhwnd, (uint)WM_COMMAND,
                    (IntPtr)ID_IE_CONTEXTMENU_ADDFAV, nullHwnd);

                this.InitNodes();
            }
        }

        
        private object mNullObj;
        //IShecllHelper
        private int ShellUIHelperMiscCommands(string scommand) {
            int hr = S_OK;
            Type shelluitype = Type.GetTypeFromCLSID(CLSID_ShellUIHelper, true);
            IShellUIHelper uihelper = (IShellUIHelper)System.Activator.CreateInstance(shelluitype);
            uihelper.ShowBrowserUI(scommand, ref mNullObj);
            return hr;
        }
        public void OrganizeFavorites() {
            ShellUIHelperMiscCommands("OrganizeFavorites");
        }

        
    }


    [ComImport, ComVisible(true)]
    [Guid("00000114-0000-0000-C000-000000000046")]
    [InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
    public interface IOleWindow {
        //IOleWindow
        [return: MarshalAs(UnmanagedType.I4)]
        [PreserveSig]
        int GetWindow([In, Out] ref IntPtr phwnd);

        [return: MarshalAs(UnmanagedType.I4)]
        [PreserveSig]
        int ContextSensitiveHelp([In, MarshalAs(UnmanagedType.Bool)] bool
            fEnterMode);
    }

    [ComVisible(false),
    Guid("729FE2F8-1EA8-11d1-8F85-00C04FC2FBE1"),
    InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIDispatch)]
    public interface IShellUIHelper {
        [DispId(1)]
        void ResetFirstBootMode(); //[hidden]
        [DispId(2)]
        void ResetSafeMode(); //[hidden]
        [DispId(3)]
        void RefreshOfflineDesktop(); //[hidden]

        [DispId(4)]
        void AddFavorite(
            [In, MarshalAs(UnmanagedType.BStr)] string URL,
            [In] object Title);

        [DispId(5)]
        void AddChannel(
            [In, MarshalAs(UnmanagedType.BStr)] string URL);

        [DispId(6)]
        void AddDesktopComponent(
            [In, MarshalAs(UnmanagedType.BStr)] string URL,
            [In, MarshalAs(UnmanagedType.BStr)] string Type,
            [In] ref object Left, [In] ref object Top,
            [In] ref object Width, [In] ref object Height);

        [DispId(7)]
        [return: MarshalAs(UnmanagedType.VariantBool)]
        bool IsSubscribed(
            [In, MarshalAs(UnmanagedType.BStr)] string URL);

        [DispId(8)]
        void NavigateAndFind(
            [In, MarshalAs(UnmanagedType.BStr)] string URL,
            [In, MarshalAs(UnmanagedType.BStr)] string strQuery,
            ref object varTargetFrame);

        [DispId(9)]
        void ImportExportFavorites(
            [In, MarshalAs(UnmanagedType.VariantBool)] bool fImport,
            [In, MarshalAs(UnmanagedType.BStr)] string strImpExpPath);

        [DispId(10)]
        void AutoCompleteSaveForm(ref object Form);

        [DispId(11)]
        void AutoScan(
            [In, MarshalAs(UnmanagedType.BStr)] string strSearch,
            [In, MarshalAs(UnmanagedType.BStr)] string strFailureUrl,
            [In, Optional] ref object pvarTargetFrame);

        [DispId(12)]
        void AutoCompleteAttach(ref object Reserved);  //[hidden]

        [DispId(13)]
        object ShowBrowserUI(
            [In, MarshalAs(UnmanagedType.BStr)] string bstrName,
            [In] ref object pvarIn);
    }


    internal class FaviconFinder {
        private Dictionary<string, Icon> _items;
        private Dictionary<string, string> _urlDictionary;

        private readonly object _sync;

        private WaitCallback _wcb;
        public event EventHandler<FaviconFindEventArgs> SearchComplete;

        private WaitCallback _wcbDl;
        public event EventHandler<FaviconDownloadedEventArgs> FaviconDownloaded;

        public FaviconFinder() {
            _sync = new object();
            _urlDictionary = new Dictionary<string, string>();
            _items = new Dictionary<string, Icon>();
            _wcb = new WaitCallback(this.WaitCallBackTP);
            _wcbDl = new WaitCallback(this.WaitCallBackDlIcon);
        }

        public Dictionary<string,Icon> Items {
            get {
                lock (_sync) {
                    return _items;
                }
            }
        }


        public void SearchFavicon(string url) {
            ThreadPool.QueueUserWorkItem(_wcb, url);
        }
        public void DownLoadFavicon(string favRoot, string urlOrg) {
            ThreadPool.QueueUserWorkItem(_wcbDl, new string[] { favRoot, urlOrg });
        }
        private void WaitCallBackTP(object target) {
            string url = target as string;
            if (url == null || url.Length == 0) {
                if (this.SearchComplete != null) {
                    this.SearchComplete(this, new FaviconFindEventArgs(false, "", url));
                    return;
                }
            }
            lock (_sync) {
                if (_urlDictionary.ContainsKey(url)) {
                    if (this.SearchComplete != null) {
                        this.SearchComplete(this, new FaviconFindEventArgs(true, _urlDictionary[url], url));
                    }
                }
            }

            Uri uri = null;
            try {
                uri = new Uri(url);
            } catch {
                if (this.SearchComplete != null) {
                    this.SearchComplete(this, new FaviconFindEventArgs(false, "", url));
                }
                return;
            }
            
            string[] urla = url.Split('/');
            string urlr = url;
            string urlf = url;
            int depth=urla.Length-1;
            HttpWebRequest req = null;
            while (depth>0) {
                urlr = urlr.Substring(0, urlr.Length - urla[depth].Length - 1);
                urlf = urlr + "/favicon.ico";
                HttpWebResponse res = null;
                bool ok = true;
                try {
                    req = WebRequest.Create(urlf) as HttpWebRequest;
                    res = req.GetResponse() as HttpWebResponse;
                } catch {
                    ok = false;
                } finally {
                    if (res != null) res.Close();
                }
                if (ok) {
                    lock (_sync) {
                        if (!this._items.ContainsKey(urlf)) {
                            this._items.Add(urlf, null);                        
                        }
                        this._urlDictionary[url] = urlf;
                    }
                    if (this.SearchComplete != null) {
                        this.SearchComplete(this, new FaviconFindEventArgs(true, urlf, url));
                    }
                    return;
                }
                depth--;
            }
            if (this.SearchComplete != null) {
                this.SearchComplete(this, new FaviconFindEventArgs(false, "", url));
            }
        }

        private void WaitCallBackDlIcon(object target) {
            string[] urls = target as string[];
            if (urls == null || urls.Length != 2) {
                return;
            }
            string url = urls[0];
            string urlOrg = urls[1];

            if (url == null || url.Length == 0) {
                if (this.FaviconDownloaded != null)
                    this.FaviconDownloaded(this, new FaviconDownloadedEventArgs(false, null, urlOrg, ""));
                return;
            }
            lock (_sync) {
                if (this._items.ContainsKey(url)) {
                    Icon icbuf = this._items[url];
                    if (icbuf != null) {
                        if (this.FaviconDownloaded != null)
                            this.FaviconDownloaded(this, new FaviconDownloadedEventArgs(true, icbuf, urlOrg, url));
                        return;
                    }
                }
            }

            Bitmap bmp = null;
            Icon ic = null;
            using (WebClient wc = new WebClient()) {
                try {
                    using (Stream s = wc.OpenRead(url))
                    using (Bitmap b = new Bitmap(s)) {
                        bmp = new Bitmap(b);
                        /*
                        bmp = new Bitmap(im.Width, im.Height);
                        using (Graphics g = Graphics.FromImage(im)) {
                            g.Clear(Color.Transparent);
                            g.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver;
                            g.DrawImage(im, 0, 0, im.Width, im.Height);
                        }*/
                        bmp.MakeTransparent();
                        ic = Icon.FromHandle(bmp.GetHicon());
                    }
                
                } catch (Exception ex) {
                    ic = null;
                } finally {
                }
            }

            if (this.FaviconDownloaded != null) {
                if (ic != null) {
                    lock (_sync) {
                        if (this._items.ContainsKey(url)) {
                            this._items[url] = ic;
                        } else {
                            this._items.Add(url, ic);
                        }
                        if (this._urlDictionary.ContainsKey(urlOrg)) {
                            this._urlDictionary[urlOrg] = url;
                        } else this._urlDictionary.Add(urlOrg, url);
                    }
                    this.FaviconDownloaded(this, new FaviconDownloadedEventArgs(true, ic, urlOrg, _urlDictionary[urlOrg]));
                } else {
                    this.FaviconDownloaded(this, new FaviconDownloadedEventArgs(false, null, urlOrg, _urlDictionary[urlOrg]));
                }
            }
        }
    }

    internal class FaviconFindEventArgs : EventArgs {
        private bool _found;
        private string _foundUrl;
        private string _searchUrl;

        public FaviconFindEventArgs(bool found, string url, string searchUrl) {
            _found = found;
            _foundUrl = url;
            _searchUrl = searchUrl;
        }
        public string FoundUrl {
            get { return _foundUrl; }
        }
        public string SearchUrl {
            get { return _searchUrl; }
        }
        public bool Found {
            get { return _found; }
        }
    }
    internal class FaviconDownloadedEventArgs : FaviconFindEventArgs {
        private Icon _ic;
        public FaviconDownloadedEventArgs(bool found, Icon ic, string srchUrl, string foundUrl)
            : base(found, foundUrl, srchUrl) {
            _ic = ic;
        }
        public Icon Icon {
            get { return _ic; }
        }
    }
}
