﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
//Additional Includes:
using System.IO;
using System.Resources;
using System.Reflection;


namespace DomainGenie
{
    public partial class DictionaryForm : Form
    {
        String vlcInstallDirectory = string.Empty;
            
        private ListViewItem[] lvi;

        Dictionary<int[], string> _listDict = new Dictionary<int[], string>();
        Dictionary<int[], string> _listLists = new Dictionary<int[], string>();


        public DictionaryForm()
        {
            SetStyle(ControlStyles.OptimizedDoubleBuffer, true);

            InitializeComponent();
        }

        void listView_RetrieveVirtualItem(object sender,
            RetrieveVirtualItemEventArgs e)
        {
            e.Item = lvi[e.ItemIndex];
        }

        void listView_DrawItem(object sender,
            DrawListViewItemEventArgs e)
        {
            e.DrawDefault = true;
            if (!e.Item.Checked)
            {
                e.Item.Checked = true;
                e.Item.Checked = false;
            }
        }

        void listView_MouseClick(object sender, MouseEventArgs e)
        {
            ListView lv = (ListView)sender;
            ListViewItem lvi = lv.GetItemAt(e.X, e.Y);
            if (lvi != null)
            {
                if (e.X < (lvi.Bounds.Left + 16))
                {
                    lvi.Checked = !lvi.Checked;
                    lv.Invalidate(lvi.Bounds);
                }
            }
        }

        void listView_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            ListView lv = (ListView)sender;
            ListViewItem lvi = lv.GetItemAt(e.X, e.Y);
            if (lvi != null)
                lv.Invalidate(lvi.Bounds);
        }



        private void DictionaryForm_Load(object sender, EventArgs e)
        {
            vlcInstallDirectory = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);

            _listLists = new Dictionary<int[], string>();

            ddDict.SelectedIndex = 0;
            ddWordLists.SelectedIndex = 0;

            _listDict = new Dictionary<int[], string>();

            //////////////////////////////////////////////////////////////

            vlcInstallDirectory = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);

            //_listLists = new Dictionary<int[], string>();
            _listDict = new Dictionary<int[], string>();


            int i = 0;
            string sLanguages = vlcInstallDirectory + "\\dict";
            DirectoryInfo MyRoot = new DirectoryInfo(sLanguages);
            FileInfo[] MyLanguages = MyRoot.GetFiles("*.txt");
            i = 1;
            _listDict.Add(new int[] { 0, 0 }, "");
            foreach (FileInfo F in MyLanguages)
            {
                int j = 0;
                Stream s = new FileStream(F.FullName, FileMode.Open);
                using (StreamReader sr = new StreamReader(s, Encoding.UTF8))
                {
                    string line;
                    while ((line = sr.ReadLine()) != null)
                        if (line.Length > 0)
                            j++;
                }
                string plain = F.Name.Replace(".txt", "");
                _listDict.Add(new int[] { i, j }, plain);
                i++;
            }

            //////////////////////////////////////////////////////////////

            if (DomainGenieApplication.m_bAuthorized)
            {
                //_listDict.Add(new int[] { 0, 0 }, "");
                //_listDict.Add(new int[] { 1, 133152 }, "afrikaans.txt");
                //_listDict.Add(new int[] { 2, 1893 }, "aussie.txt");
                //_listDict.Add(new int[] { 3, 442 }, "chinese.txt");
                //_listDict.Add(new int[] { 4, 28112 }, "croatian.txt");
                //_listDict.Add(new int[] { 5, 162131 }, "czech.txt");
                //_listDict.Add(new int[] { 6, 323197 }, "danish.txt");
                //_listDict.Add(new int[] { 7, 233876 }, "dutch.txt");
                //_listDict.Add(new int[] { 8, 128571 }, "english.txt");
                //_listDict.Add(new int[] { 9, 634699 }, "englishall.txt");
                //_listDict.Add(new int[] { 10, 301515 }, "finnish.txt");
                //_listDict.Add(new int[] { 11, 167568 }, "french.txt");
                //_listDict.Add(new int[] { 12, 208753 }, "german.txt");
                //_listDict.Add(new int[] { 13, 750 }, "hindu.txt");
                //_listDict.Add(new int[] { 14, 17883 }, "hungarian.txt");
                //_listDict.Add(new int[] { 15, 344491 }, "italian.txt");
                //_listDict.Add(new int[] { 16, 115521 }, "japanese.txt");
                //_listDict.Add(new int[] { 17, 76990 }, "latin.txt");
                //_listDict.Add(new int[] { 18, 68580 }, "norwegian.txt");
                //_listDict.Add(new int[] { 19, 109851 }, "polish.txt");
                //_listDict.Add(new int[] { 21, 86061 }, "spanish.txt");
                //_listDict.Add(new int[] { 22, 29513 }, "swedish.txt");
                //_listDict.Add(new int[] { 23, 25854 }, "turkish.txt");
                //_listDict.Add(new int[] { 24, 2712 }, "xhosa.txt");
                //_listDict.Add(new int[] { 25, 11265 }, "zulu.txt");

                //_listLists.Add(new int[] { 0, 0 }, "");
                //_listLists.Add(new int[] { 1, 498150 }, "american.txt");
                //_listLists.Add(new int[] { 2, 175816 }, "computer.txt");
                //_listLists.Add(new int[] { 3, 3562 }, "literature.txt");
                //_listLists.Add(new int[] { 4, 243408 }, "misc.txt");
                //_listLists.Add(new int[] { 5, 19314 }, "movie.txt");
                //_listLists.Add(new int[] { 6, 26656 }, "music.txt");
                //_listLists.Add(new int[] { 7, 19934 }, "music_classical.txt");
                //_listLists.Add(new int[] { 8, 2407 }, "music_country.txt");
                //_listLists.Add(new int[] { 9, 6662 }, "music_jazz.txt");
                //_listLists.Add(new int[] { 10, 15162 }, "music_other.txt");
                //_listLists.Add(new int[] { 11, 12340 }, "music_rock.txt");
                //_listLists.Add(new int[] { 12, 1842 }, "music_shows.txt");
                //_listLists.Add(new int[] { 13, 217387 }, "names.txt");
                //_listLists.Add(new int[] { 14, 406 }, "religion.txt");
                //_listLists.Add(new int[] { 15, 26363 }, "science.txt");
                //_listLists.Add(new int[] { 16, 2091 }, "shakespeare.txt");
                //_listLists.Add(new int[] { 17, 1387 }, "special_english.txt");
            }

        }

        private void BTN_AddRandom_Click(object sender, EventArgs e)
        {
            if ((!DomainGenieApplication.m_bAuthorized))
            {
                MessageBox.Show("Sorry you need to purchase a licensed copy to use database!");
                return;
            }
            if (listViewWords.VirtualListSize < 1)
            {
                MessageBox.Show("You must first load a dictionary of word list!");
                return;
            }

            Random randNum = new Random();
            //randNum.Next(108); // No larger than 108

            int i = 0;
            i = randNum.Next(listViewWords.VirtualListSize);
            int newrow = 0;
            int j = 0;
            for(int p = 0; p < listViewWords.VirtualListSize; p++)
            {
                if (j > i)
                {
                    ListViewItem lvItem = new ListViewItem();
                    lvItem = listViewRandom.Items.Add(listViewWords.Items[p].SubItems[0].Text, 1);
                    lvItem.Checked = true;
                    newrow++;
                    i = i + randNum.Next(listViewWords.VirtualListSize);
                }
                j++;
            }

        }

        private void BTN_DictStarts_Click(object sender, EventArgs e)
        {
            if ((!DomainGenieApplication.m_bAuthorized))
            {
                MessageBox.Show("Sorry you need to purchase a licensed copy to use database!");
                return;
            }
            //http://www.picozip.com/prt/index.html
            build_dictionary();
        }

        void build_dictionary()
        {
            txtInfo.Text = "loading...";
            this.listViewWords.VirtualMode = false;
            lvi = null;
            lvi = new ListViewItem[1];
            this.listViewRandom.Items.Clear();

            if (ddDict.SelectedIndex < 1)
                return;

            if ((listViewWords != null) && (listViewWords.VirtualListSize > 0))
            {
                listViewWords.Items.Clear();
            }


            int zlines = 0;
            string bb = "";
            foreach (int[] key in _listDict.Keys)
            {
                bb = string.Empty;
                zlines = 0;
                _listDict.TryGetValue(key, out bb);
                if (key[0] == ddDict.SelectedIndex)
                {
                    zlines = key[1];
                    break;
                }
            }

            bool blnVirtual = true;
            //Assembly assembly = Assembly.GetExecutingAssembly();
            //string zname = assembly.GetName().Name.ToString() + ".Resources." + bb;

            string strm = vlcInstallDirectory + "\\dict\\" + bb + ".txt";
            if (!File.Exists(strm))
                return;

            string contents = string.Empty;
            lvi = null;
            lvi = new ListViewItem[1];
            lvi = new ListViewItem[zlines];
            int nWords = 0;
            try
            {
                //Stream strm = assembly.GetManifestResourceStream(zname);
                StreamReader reader = new StreamReader(strm);
                while (reader.Peek() != -1)
                {
                    contents = reader.ReadLine().TrimEnd();
                    //_listLists.Add(nWords, contents);
                    lvi[nWords] = new ListViewItem(contents);
                    nWords++;
                }
                reader.Close();
            }
            catch (IOException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
            catch (ArgumentNullException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
            txtInfo.Text = String.Format("{0:0,0}  words loaded...", nWords);
            //myStatusText.Text = "Ready, " + SpellChecker.Count.ToString() + " Words in dictionary.";
            //Array.Clear(wordArray, 0, nWords - 1);
            SetupListview(blnVirtual);

        }

        void build_wordlist()
        {
            this.listViewWords.VirtualMode = false;
            lvi = null;
            lvi = new ListViewItem[1];
            this.listViewRandom.Items.Clear();

            if (ddWordLists.SelectedIndex < 1)
                return;

            if ((listViewWords != null) && (listViewWords.VirtualListSize > 0))
            {
                listViewWords.Items.Clear();
            }


            int zlines = 0;
            string bb = "";
            foreach (int[] key in _listLists.Keys)
            {
                bb = string.Empty;
                zlines = 0;
                _listLists.TryGetValue(key, out bb);
                if (key[0] == ddWordLists.SelectedIndex)
                {
                    zlines = key[1];
                    break;
                }
            }

            bool blnVirtual = true;
            //Assembly assembly = Assembly.GetExecutingAssembly();
            //string zname = assembly.GetName().Name.ToString() + ".Resources." + bb;

            string strm = vlcInstallDirectory + "\\lists\\" + bb;
            if (!File.Exists(strm))
                return;

            string contents = string.Empty;
            lvi = null;
            lvi = new ListViewItem[1];
            lvi = new ListViewItem[zlines];
            try
            {
                //Stream strm = assembly.GetManifestResourceStream(zname);
                StreamReader reader = new StreamReader(strm);
                int nWords = 0;
                while (reader.Peek() != -1)
                {
                    contents = reader.ReadLine().TrimEnd();
                    //_listLists.Add(nWords, contents);
                    lvi[nWords] = new ListViewItem(contents);
                    nWords++;
                }
                reader.Close();
            }
            catch (IOException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
            catch (ArgumentNullException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }

            //myStatusText.Text = "Ready, " + SpellChecker.Count.ToString() + " Words in dictionary.";
            //Array.Clear(wordArray, 0, nWords - 1);
            SetupListview(blnVirtual);

        }

        void SetupListview(bool blnVirtual)
        {
            // Force it to be virtual
            blnVirtual = true;
            this.listViewWords.VirtualMode = false;
            this.listViewWords.View = View.List;
            this.listViewWords.CheckBoxes = true;

            if (blnVirtual)
            {
                // This makes it real fast!!
                this.listViewWords.RetrieveVirtualItem += new RetrieveVirtualItemEventHandler(listView_RetrieveVirtualItem);
                this.listViewWords.VirtualListSize = lvi.Length;
                this.listViewWords.VirtualMode = true;

                // This is for drawing unchecked checkboxes
                this.listViewWords.OwnerDraw = true;
                this.listViewWords.DrawItem += new DrawListViewItemEventHandler(listView_DrawItem);

                // Redraw when checked or doubleclicked
                this.listViewWords.MouseClick += new MouseEventHandler(listView_MouseClick);
                this.listViewWords.MouseDoubleClick += new MouseEventHandler(listView_MouseDoubleClick);
            }
            else
            {
                listViewWords.Items.AddRange(lvi);
            }
        }

        void delete_item()
        {
            ListView.SelectedListViewItemCollection slvic = this.listViewWords.SelectedItems;

            foreach (ListViewItem item in slvic)
            {
                listViewWords.Items.Remove(item);
            }

            if (this.listViewWords.Items.Count == 0)
                Console.WriteLine("Empty");
        }

        private void BTN_DictClear_Click(object sender, EventArgs e)
        {
            txtInfo.Text = "";
            this.listViewWords.VirtualMode = false;
            lvi = null;
            lvi = new ListViewItem[1];
            this.listViewRandom.Items.Clear();

        }

        private void BTN_RandomClear_Click(object sender, EventArgs e)
        {
            this.listViewRandom.Items.Clear();
        }

        // Method 2 (using string modifiers)
        public static string ExtractDomainNameFromURL_Method2(string Url)
        {
            if (Url.Contains(@"://"))
                Url = Url.Split(new string[] { "://" }, 2, StringSplitOptions.None)[1];

            return Url.Split('/')[0];
        }

        private void BTN_Dict_AddWord_Click(object sender, EventArgs e)
        {
            string zdomain = string.Empty;

            for (int i = 0; i < listViewWords.VirtualListSize; i++)
            {
                zdomain = listViewWords.Items[i].Text;
                if (listViewWords.Items[i].Checked)
                    AddToDomains(zdomain);
            }
        }

        private void BTN_Dict_AddRandom_Click(object sender, EventArgs e)
        {
            string zdomain = string.Empty;

            for (int i = 0; i < listViewRandom.CheckedIndices.Count; i++)
            {
                zdomain = listViewRandom.CheckedItems[i].Text;
                AddToDomains(zdomain);
            }
        }

        void AddToDomains(string zdomain)
        {
            string sProject = "default";
            if (sProject.Length < 1)
                sProject = "None";

            bool bFound = false;
            int i = DomainGenie.DomainGenieApplication.DomListView.Items.Count;


            zdomain.ToLower();
            zdomain = ExtractDomainNameFromURL_Method2(zdomain);
            if (zdomain.IndexOf(".") != -1)
                if (zdomain.IndexOf(".") < zdomain.Length - 4)
                    zdomain = zdomain.Substring(zdomain.IndexOf(".") + 1);

            if (zdomain.LastIndexOf(".") < 0)
                zdomain = zdomain + ".com";

            int cc = zdomain.IndexOf("/");
            if ((cc != -1) && (zdomain.Length > cc + 1))
                zdomain = zdomain.Substring(cc);

            cc = zdomain.IndexOf(":");
            if ((cc != -1) && (zdomain.Length > cc + 1))
                zdomain = zdomain.Substring(cc);

            cc = zdomain.IndexOf(";");
            if ((cc != -1) && (zdomain.Length > cc + 1))
                zdomain = zdomain.Substring(cc);

            for (int j = 0; j < DomainGenie.DomainGenieApplication.DomListView.Items.Count; j++)
            {
                string test_domain = DomainGenie.DomainGenieApplication.DomListView.Items[j].SubItems[1].Text;
                if (zdomain.CompareTo(test_domain) == 0)
                    bFound = true;
            }

            string newrow = DomainGenie.DomainGenieApplication.DomListView.Items.Count.ToString();
            if ((!bFound) && (zdomain.Length > 4))
            {
                ListViewItem lvItem = new ListViewItem();
                lvItem = DomainGenie.DomainGenieApplication.DomListView.Items.Add(newrow, 1);
                lvItem.Checked = true;
                lvItem.SubItems.Add(zdomain);
                lvItem.SubItems.Add("");
                lvItem.SubItems.Add("");
                lvItem.SubItems.Add("Unknown");
                lvItem.SubItems.Add(sProject);
                lvItem.SubItems.Add("Unknown");
                i++;
            }
        }

        private void BTN_WordLists_Click(object sender, EventArgs e)
        {
            build_wordlist();
        }

        private void BTN_AddWordThatStartWith_Click(object sender, EventArgs e)
        {
            string s1 = txtStartWith.Text.TrimEnd();
            if (s1.Length < 1)
                return;

            txtInfo.Text = "";
            string sStartWith = s1.Substring(0, 1); 
            string zdomain = string.Empty;
            int nWords = 0;
            for (int i = 0; i < listViewWords.VirtualListSize; i++)
            {
                zdomain = listViewWords.Items[i].Text;
                if (listViewWords.Items[i].Text.StartsWith(sStartWith, true, System.Globalization.CultureInfo.InvariantCulture))
                {
                    AddToDomains(zdomain);
                    nWords++;
                }
            }
            txtInfo.Text = String.Format("{0:0,0}  words loaded...", nWords);
        }



    }


}